"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getImportsWithLocal = exports.custumIncludePattern = exports.customIncludeDirs = exports.Includes = exports.IncludeFile = void 0;
const vscode_1 = require("vscode");
const pathns = __importStar(require("path"));
const fs = __importStar(require("fs"));
class IncludeFile {
    constructor(path) {
        this.Content = "";
        let path2 = path;
        if (!pathns.isAbsolute(path2))
            path2 = pathns.join(vscode_1.workspace.workspaceFolders[0].uri.fsPath, path2);
        this.Uri = vscode_1.Uri.file(path2);
        if (fs.existsSync(path2) && fs.statSync(path2).isFile())
            this.Content = fs.readFileSync(path2).toString();
    }
}
exports.IncludeFile = IncludeFile;
exports.Includes = new Map();
exports.customIncludeDirs = vscode_1.workspace.getConfiguration("vbs").get("customIncludeDirs");
exports.custumIncludePattern = new RegExp(vscode_1.workspace.getConfiguration("vbs").get("custumIncludePattern"), "ig");
function getImportsWithLocal(doc) {
    var _a, _b;
    const localIncludes = [...exports.Includes];
    const processedMatches = Array();
    let match;
    while ((match = exports.custumIncludePattern.exec(doc.getText())) !== null) {
        if (processedMatches.indexOf(match[1].toLowerCase())) {
            for (const incDir of exports.customIncludeDirs) {
                let incDirResolved = incDir;
                if (incDirResolved === ".")
                    incDirResolved = vscode_1.workspace.workspaceFolders[0].uri.fsPath;
                if (incDirResolved === "..")
                    incDirResolved = pathns.dirname(vscode_1.workspace.workspaceFolders[0].uri.fsPath);
                const path = pathns.resolve(incDirResolved, match[1]);
                if (fs.existsSync(path) && ((_a = fs.statSync(path)) === null || _a === void 0 ? void 0 : _a.isFile()))
                    localIncludes.push([
                        `Import Statement ${match[1]}`,
                        new IncludeFile(path)
                    ]);
                else if (fs.existsSync(`${path}.vbs`) && ((_b = fs.statSync(`${path}.vbs`)) === null || _b === void 0 ? void 0 : _b.isFile()))
                    localIncludes.push([
                        `Import Statement ${match[1]}`,
                        new IncludeFile(`${path}.vbs`)
                    ]);
            }
            processedMatches.push(match[1].toLowerCase());
        }
    }
    return localIncludes;
}
exports.getImportsWithLocal = getImportsWithLocal;
//# sourceMappingURL=Includes.js.map